;===========================================================================================//
; Auto reload v0.9 (reload.mrc) for mIRC 6.02
; by vague (msandin@hotmail.com)
;===========================================================================================\\

ALIAS autoreload setup
ALIAS arl autoreload.check
MENU menubar {
  Auto reload
  .Setup... { setup }
  .-
  .Uninstall { autoreload.uninstall }
}

;-------------------------------------------------------------------------------------------/
; Script interface
;-------------------------------------------------------------------------------------------\
ALIAS autoreload.version {
  return 0.9
}
ALIAS autoreload.setup {
  setup
}
ALIAS autoreload.check {
  check
}
ALIAS autoreload.get {
  if ($findtok(remote alias hide delay,$1,1,32)) {
    return $retr($1)
  }
}
ALIAS autoreload.set {
  if ($findtok(remote alias hide delay,$1,1,32) && $2 isnum) {
    put $1 $2
    if ($show) {
      echo $color(info) -a *** Auto reload option ' $+ $1 $+ ' set to ' $+ $2 $+ '
    }
    .start
  }
}
ALIAS autoreload.uninstall {
  if ($hget(autoreload)) {
    hfree autoreload
  }
  .timerAUTORELOAD off
  .remove " $+ $scriptdir $+ reload.ini"
  .timer 1 0 !.unload -rs $script
  if ($show) {
    echo $color(info) -a *** Auto reload uninstalled
  }
}

;-------------------------------------------------------------------------------------------/
; Main
;-------------------------------------------------------------------------------------------\
ALIAS -l check {
  var %i, %k, %f
  if ($hget(autoreload) == $null) {
    autoreload.init
  }
  if ($hget(autoreload,remote)) {
    %i = 1
    while ($script(%i)) {
      %f = $script(%i)
      %k = $key(r,%f)
      if ($hget(autoreload,%k)) {
        if ($file(%f).mtime != $hget(autoreload,%k)) {
          hadd autoreload %k $ifmatch
          if ($key(r,$script) == %k) {
            .timer 1 0 ! $+ $hget(autoreload,hide) $+ reload -rs " $+ %f $+ "
          }
          else {
            ! $+ $hget(autoreload,hide) $+ reload -rs " $+ %f $+ "
          }
        }
      }
      else {
        hadd autoreload %k $file(%f).mtime
      }
      inc %i
    }
  }
  if ($hget(autoreload,alias)) {
    %i = 1
    while ($alias(%i)) {
      %f = $alias(%i)
      %k = $key(a,%f)
      if ($file(%f).mtime != $hget(autoreload,%k)) {
        hadd autoreload %k $ifmatch
        ! $+ $hget(autoreload,hide) $+ reload -a " $+ %f $+ "
      }
      inc %i
    }
  }
}
ALIAS -l start {
  var %i
  init
  if ($hget(autoreload)) {
    hfree autoreload
  }
  .timerAUTORELOAD off
  if (($retr(remote) || $retr(alias)) && $retr(delay)) {
    hmake autoreload 20
    hadd autoreload remote $retr(remote)
    hadd autoreload alias $retr(alias)
    hadd autoreload hide $iif($retr(hide),.)
    hadd autoreload delay $retr(delay)
    %i = 1
    while ($script(%i)) {
      hadd autoreload $key(r,$script(%i)) $file($script(%i)).mtime
      inc %i
    }
    %i = 1
    while ($alias(%i)) {
      hadd autoreload $key(a,$alias(%i)) $file($alias(%i)).mtime
      inc %i
    }
    .timerAUTORELOAD -o 0 $hget(autoreload,delay) autoreload.check
     if ($show || ($retr(first)))  echo $color(info) -a *** Auto reload v $+ $autoreload.version started ( $+ $hget(autoreload,delay) second delay)
     put first 0
  }
}

;-------------------------------------------------------------------------------------------/
; Setup
;-------------------------------------------------------------------------------------------\
ALIAS -l setup {
  init
  dialog -m autoreload autoreload
  dialog -t autoreload Auto reload v $+ $autoreload.version
  did $iif($retr(remote),-c,-u) autoreload 10
  did $iif($retr(alias),-c,-u) autoreload 11
  did $iif($retr(hide),-c,-u) autoreload 12
  did -o autoreload 13 1 $retr(delay)
  did -o autoreload 30 1 $retr(delay)
}
DIALOG autoreload {
  TITLE ""
  SIZE -1 -1 96 78
  OPTION dbu
  BUTTON "OK", 1, 17 62 28 13, OK
  BUTTON "Cancel", 2, 48 62 28 13, CANCEL
  CHECK "Reload &remote files", 10, 8 2 60 10
  CHECK "Reload &alias files", 11, 8 12 60 10
  TEXT "Check every:", 20, 8 28 35 10
  EDIT "", 13, 42 26 16 11, LIMIT 3
  EDIT "", 30, 42 26 16 11, HIDDEN
  TEXT "seconds", 21, 60 28 20 10
  CHECK "&Hide reloads", 12, 8 43 60 10
}

ON *:DIALOG:autoreload:SCLICK:1 {
  put remote $did(autoreload,10).state 
  put alias $did(autoreload,11).state
  put hide $did(autoreload,12).state
  put delay $iif($did(autoreload,13).text,$ifmatch,0)
  .start
}
ON *:DIALOG:autoreload:EDIT:13 {
  if ($did(autoreload,13).text !isnum && $did(autoreload,13).text != $null) {
    did -o autoreload 13 1 $did(autoreload,30).text
  }
  else {
    did -o autoreload 30 1 $did(autoreload,13).text
  }
}
ALIAS -l init {
  if ($retr(remote) == $null) put remote 0
  if ($retr(alias) == $null) put alias 0
  if ($retr(hide) == $null) put hide 0
  if ($retr(delay) !isnum) put delay 1
}

;-------------------------------------------------------------------------------------------/
; Events
;-------------------------------------------------------------------------------------------\
ON *:LOAD {
  setup
  put first 1
}
ON *:START {
  start
}

;-------------------------------------------------------------------------------------------/
; Lib
;-------------------------------------------------------------------------------------------\
ALIAS -l key {
  return $1 $+ : $+ $replace($2-,$chr(32),")
}
ALIAS -l retr {
  return $readini($scriptdir $+ reload.ini,setup,$1)
}
ALIAS -l put {
  writeini " $+ $scriptdir $+ reload.ini" setup $1 $2-
}
ALIAS -l reload {
  ! $+ $hget(autoreload,hide) $+ reload $1 " $+ $2- $+ "
}
